<?php

include("config.php");
require_once('rss10.inc');
$version = "0.1 alpha";

$rssobj = new RSSWriter($nagios['myurl'], "Nagios Status Feed", "RSS Nagios Status Feed");
$rssobj->
//$oktoo = $_GET["oktoo"];
$oktoo = true;

$fp = fopen($nagios['status_file'], "r");

if (!$fp) { echo "<p>Unable to open " . $nagios['status_file'] . "for reading!"; exit; }

while (!feof($fp)):
	$fline = fgets($fp);
	
	/*
	 * If this is a HOST entry, we need to parse for hosts.
	 * else we need to parse for services.
	 */
	 $pos = strpos($fline, "HOST");
	 
	 if($pos == false) {
 		$pos = strpos($fline, "SERVICE");
		if ($pos != false) {
	 		// This is a service check.
			parseService($fline);
	 	} 
	 } else { 
	 	parseHost($fline);
	 }
endwhile;
$rssobj->serialize();
fclose($fp);
exit;

function parseHost( $line ) {
	global $rssobj;
	global $oktoo;
	global $nagios;
	global $version;
	
	//echo "DEBUG: parseHost got " . $line;
	
	list ($ts, $leftovers) = explode(" ", $line);
	list($svctype, $hostname, $status, $lastcheck, $laststate, $ack,
		$timeup, $timedown, $timeunreach, $lastnotification,
		$curnotification, $notifyenabled, $eventenabled,
		$checkenabled, $flapenabled, $percentchange,
		$scheddndepth, $failpredectenabled, $procperf, $plugout) = explode(";", $leftovers);
	
	if ( $oktoo == true ) {
		$rssobj->addItem($nagios['statcgi'] . "?host=" . $hostname, "Host: " . $hostname . " - " . $status,
				array("description" => $hostname . " is " . $status,
					  "dc:subject" => $hostname,
					  "dc:creator" => "Nagios-rss " . $version ));
	} else { 
		
		if (strcasecmp($status, "OK") != 0 || strcasecmp($status, "UP") != 0) {
				$rssobj->addItem($nagios['statcgi'] . "?host=" . $hostname, "Host: " . $hostname . " - " . $status,
					array("description" => $hostname . " is " . $status,
						"dc:subject" => $hostname,
						"dc:creator" => "Nagios-rss " . $version ));
		}
	}
}

function parseService( $line ) {
	global $rssobj;
	global $oktoo;
	global $nagios;
	global $version;
	
	list($ts, $leftovers) = explode(" ", $line);
	//echo "DEBUG: leftovers: " . $leftovers . "\n\r";
	list($svctype, $hostname, $description, $status, $retry, $state, $lastcheck, 
		 $nextcheck, $checktype, $checksenabled, $acceptpassive, $eventenabled, 
		 $laststate, $acknowledged, $lasthardstate, $timeok, $timeunknown, 
		 $timewarning, $timecritical, $lastnotification, $currentnotification, 
		 $notificationsenabled, $latency, $exectime, $flapdetectenabled, 
		 $serviceflapping, $percentchange, $scheddndepth, $failpredictenabled, 
		 $procperf, $obsess, $plugout) = explode(";", $leftovers);
	
	//echo "Hostname: " . $hostname . "  Service: " . $description . "\n\r";
	// https://solutions.nicusa.com/nagios/cgi-bin/extinfo.cgi?type=2&host=access%2Dsw%2D1%2Ecdc%2Enicusa%2Ecom&service=ping
	if($oktoo == true) {
		$rssobj ->addItem($nagios['extinfocgi']."?type=2&host=" . $hostname . "&service= " . $description, "Service: " . $description . " on " . $hostname . " is " . $status,
			array("description" => $description . " on " . $hostname . " is " . $status,
				  "dc:subject" => $description,
				  "dc:creator" => "Nagios-rss " . $version));
	} else { 
		// echo "STATUS: " . $status . "\n\r";
		if (strcasecmp($status, "OK") != 0 || strcasecmp($status, "UP") != 0) {
			$rssobj->addItem($nagios['extinfocgi'] . "?type=2&host=" . $hostname . "&service=" . $description, "Service: " . $description . " on " . $hostname . " is " . $status,
			array("description" => $description . " on " . $hostname . " is " . $status, 
				  "dc:subject" => $description,
				  "dc:creator" => "Nagios-rss " . $version));
		}
	}
}
 
?>
